/******************************************************************************
 * @file     Global_Variable.h
 * @brief    Global Variable header file
 *
 * @note
 * Copyright (C) 2016 Nuvoton Technology Corp. All rights reserved.
 ******************************************************************************/
#ifndef __Global_Variable_H__
#define __Global_Variable_H__

#include <stdint.h>
extern uint32_t G12TimeCounter, G34TimeCounter, G5TimeCounter, RGB1TimeCounter;
extern uint8_t G12LightingMode, G34LightingMode, G5LightingMode, RGB1LightingMode;
extern uint8_t G12BreathingSpeed, G34BreathingSpeed, G5BreathingSpeed, RGB1BreathingSpeed;
extern uint8_t G12Brightness, G34Brightness, G5Brightness, RGB1Brightness;
extern uint32_t RandomG1, RandomG2, RandomG3, RandomG4, RandomG5, RandomRGB1;
extern uint8_t ptrG1Color[8], ptrG2Color[8], ptrG3Color[8], ptrG4Color[8], ptrG5Color[8], ptrRGB1Color[8];
extern uint8_t ptrG1Bright[8], ptrG2Bright[8], ptrG3Bright[8], ptrG4Bright[8], ptrG5Bright[8], ptrRGB1Bright[8];

extern uint8_t *ptrG1_ColorArray, *ptrG2_ColorArray, *ptrG3_ColorArray, *ptrG4_ColorArray, *ptrG5_ColorArray, *ptrRGB1_ColorArray;
extern uint8_t G12ColorSize, G34ColorSize, G5ColorSize, RGB1ColorSize;
extern uint8_t *ptrG12BrightArray, *ptrG34BrightArray, *ptrG5BrightArray, *ptrRGB1BrightArray;
extern uint8_t G12BrightSize, G34BrightSize, G5BrightSize, RGB1BrightSize;
extern uint8_t *ptrG12RateArray, *ptrG34RateArray, *ptrG5RateArray, *ptrRGB1RateArray;
extern uint8_t G12MaxBright, G34MaxBright, G5MaxBright, RGB1MaxBright;
extern uint32_t G1_R_CMP, G1_G_CMP, G1_B_CMP, G2_R_CMP, G2_G_CMP, G2_B_CMP, G3_R_CMP, G3_G_CMP, G3_B_CMP, G4_R_CMP, G4_G_CMP, G4_B_CMP,
				 G5_R_CMP, G5_G_CMP, G5_B_CMP, RGB1_R_CMP, RGB1_G_CMP, RGB1_B_CMP;
extern uint32_t G12TempCal, G34TempCal, G5TempCal, RGB1TempCal;

extern uint32_t GraphicTimeCounter, BarTimeCounter, StripeTimeCounter;
extern uint8_t GraphicMaxBright, BarMaxBright, StripeMaxBright;
#define cGraphic_LED 9
extern uint8_t DataGraphic[cGraphic_LED*24];
#define cBar_LED 5
extern uint8_t DataBar[cBar_LED*24];
#define cStripe_LED 12
extern uint8_t DataStripe[cStripe_LED*24];

extern uint32_t GraphicTimeCounter, BarTimeCounter, StripeTimeCounter;
extern uint8_t GraphicBrightness, BarBrightness, StripeBrightness;
extern uint8_t GraphicLightingMode, BarLightingMode, StripeLightingMode;
extern uint8_t GraphicSpeed, BarSpeed, StripeSpeed;
extern uint8_t GraphicBrightness, BarBrightness, StripeBrightness;		

typedef void (*Graphic_FUNC)(uint32_t *CountingTime);
static volatile Graphic_FUNC Graphic_Fn;
extern void *Graphic_ptr[13];
typedef void (*Bar_FUNC)(uint32_t *CountingTime);
static volatile Bar_FUNC Bar_Fn;
extern void *Bar_ptr[13];
typedef void (*Stripe_FUNC)(uint32_t *CountingTime);
static volatile Stripe_FUNC Stripe_Fn;
extern void *Stripe_ptr[13];

extern uint8_t G12RGBColor[2][3];
extern uint8_t G34RGBColor[2][3];
extern uint8_t G5RGBColor[2][3];
extern uint8_t RGB1RGBColor[2][3];
extern uint8_t BarRGBColor[2][3];
extern uint8_t GraphicRGBColor[2][3];
extern uint8_t StripeRGBColor[2][3];

extern volatile uint8_t fPDMA_GraphicDone, fPDMA_BarDone, fPDMA_StripeDone;

extern uint8_t RGBBright[1];
extern const uint8_t DisableColor[1][3];
extern const uint8_t DisableBright[1];
extern const uint8_t FixedRate[3];
#define BreathingArraySize 70
extern const uint8_t BreathingBright[BreathingArraySize];													
extern const uint8_t BreathingRate[3];
#define FlashingArraySize 25
#define DoubleFlashingArraySize 31
extern const uint8_t DoubleFlashingBright[31];
extern const uint8_t DoubleFlashingRate[3];
extern const uint8_t MeteorBright[95];
extern const uint8_t StackBright[150];																	
extern const uint8_t RainbowColor[16][3];
extern const uint8_t RainbowBright[91];							 
extern const uint8_t RainbowRate[3];
extern const uint8_t LightingRate[3];

extern uint8_t G12CycleCounter, G34CycleCounter, G5CycleCounter, RGB1CycleCounter;

#endif  /* __Global_Variable__ */

/*** (C) COPYRIGHT 2016 Nuvoton Technology Corp. ***/
